<script lang="typescript">
  import {onMount} from 'svelte';

  import Glide, {
    Autoplay,
    Controls,
    Breakpoints,
    Swipe,
  } from '@glidejs/glide/dist/glide.modular.esm';

  import {Circle, CircleType} from '$lib/components/circle';
  import {Icon, IconId} from '$lib/components/icon';

  export let options = {};

  let node: HTMLDivElement;
  const State = {
    Mounted: 'mounted',
    Unmounted: 'unmounted',
  };
  let state = State.Unmounted;
  $: opacity = state === State.Mounted ? 1 : 0;

  onMount(() => {
    new Glide(node, {
      type: 'carousel',
      autoplay: 7000,
      perView: 6,
      breakpoints: {
        880: {perView: 4},
        480: {perView: 2},
      },
      ...options,
    }).mount({Autoplay, Controls, Breakpoints, Swipe});

    state = State.Mounted;
  });
</script>

<div bind:this={node} class="glide" style={`opacity: ${opacity}`}>
  <div class="glide__arrows glide__arrows--left" data-glide-el="controls">
    <Circle
      class="glide__arrow glide__arrow--left"
      data-glide-dir="<"
      tabindex="0"
      type={CircleType.Button}
    >
      <Icon id={IconId.ChevronLeft} />
    </Circle>
  </div>

  <div data-glide-el="track" class="glide__track">
    <ul class="glide__slides">
      <slot />
    </ul>
  </div>

  <div class="glide__arrows glide__arrows--right" data-glide-el="controls">
    <Circle
      class="glide__arrow glide__arrow--right"
      data-glide-dir=">"
      tabindex="0"
      type={CircleType.Button}
    >
      <Icon id={IconId.ChevronRight} />
    </Circle>
  </div>
</div>
